unit Dice;

interface

(* Notes on the TDie class:
   1) Randomize is never called in a method of this class.
      Call it yourself before rolling dice.
   2) Newly-created dice have 1 showing.
      Changing Sides resets Showing to 1.

   TDie was written by Bill Sorensen (12/28/96).
   It has been placed in the public domain.
*)

type
  TDie = class
  private
    FSides   : Word;
    FShowing : Word;
    procedure SetSides(NumSides: Word);
  public
    constructor Create(NumSides: Word);
    function Roll : Word; virtual;
    property Sides : Word
      read FSides
      write SetSides;
    property Showing : Word
      read FShowing;
  end;

implementation

procedure TDie.SetSides(NumSides: Word);
begin
  if (NumSides > 0) then
    FSides := NumSides
  else
    FSides := 1;

  FShowing := 1;
end;

constructor TDie.Create(NumSides: Word);
begin
  Sides := NumSides;  { also sets FShowing to 1 }
end;

function TDie.Roll : Word;
begin
  FShowing := Random(FSides) + 1;
  Result   := FShowing;
end;

end.
